unit maintcsvdocu;
// Test mit TCSVDocument
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, EditBtn,
  StdCtrls, csvdocument;

type

  TDatenSatz = record
    IDNR : string[3];  // Numerisch
    LfdNr: string[7];  // Numerisch
    Zahl : string[19]; // Numerisch 17,2
    Datum: string[10]; // TT.MM.JJJJ
    Text : string[20];
    Betrag: string[19]; // Numerisch 17,2
  end;


  { TForm1 }

  TForm1 = class(TForm)
    btnClose: TButton;
    btnStart: TButton;
    FileDialog: TFileNameEdit;
    lblFileDialog: TLabel;
    memLog: TMemo;
    procedure btnCloseClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;



var
  Form1: TForm1;

implementation
uses
  csvreadwrite;

var
  dSatz : TDatenSatz;
  dateiname : string;
  document : TCSVDocument;

{$R *.lfm}

//  String rechtsbündig und mit 0 auffüllen - Für Zahlenfelder
function ZeroLeftPad(value: string; length:integer; pad:char): string; overload;
begin
    result:= RightStr(StringOfChar(pad,length) + value, length );
end;
// String linksbündig, Uppercase und mit ' ' (Space) auffüllen - Für Textfelder
function SpaceRightPad(value: string; length:integer; pad:char): string; overload;
begin
   result := LeftStr(value + StringOfChar(pad,length), length );
end;

{ TForm1 }

procedure TForm1.btnStartClick(Sender: TObject);
var
   timestamp: string;
   r : integer; // für Zeile
   s : string;  // Ausgabestring
   c : integer; // Spaltenindex

begin
//  try
    memLog.Lines.Clear;
    if FileDialog.FileName <> '' then
    begin
      timestamp := DateTimeToStr(Now); //für Ausgabedatei
      document:=TCSVDocument.Create;   //document erzeugen
      document.Delimiter:=';';         //feldtrenner setzen
      document.LoadFromFile(FileDialog.FileName); //Datei laden
      memLog.Lines.Add('Datum :' + timestamp);
      memLog.Lines.Add('Anzahl Zeilen: '+IntToStr(document.RowCount));
      memLog.Lines.Add('Anzahl Spalten: '+IntToStr(document.MaxColCount));
      memLog.Lines.Add('');
      for r:=1 to document.RowCount do // Alle Zeilen verarbeiten. r:= 1 da Header Zeile vorhanden
      begin
        c:=0;
        while ((c < document.MaxColCount ) and (r <= document.RowCount-1)) do     //bis alle Spalten verarbeitet
        begin
          with dSatz do         //String formatieren und Record Felder füllen
          begin
            IDNR:= ZeroLeftPad(document.Cells[c,r],SizeOf(IDNR)-1,'0');
            Inc(c);
            LfdNr:= ZeroLeftPad(document.Cells[c,r],SizeOf(LfdNr)-1,'0');
            Inc(c);
            Zahl:= ZeroLeftPad(document.Cells[c,r],SizeOf(Zahl)-1,'0');
            Inc(c);
            Datum:=document.Cells[c,r];
            Inc(c);
            Text:= SpaceRightPad(UpperCase(document.Cells[c,r]),SizeOf(Text)-1,' ');
            Inc(c);
            Betrag:= ZeroLeftPad(document.Cells[c,r],SizeOf(Betrag)-1,'0');
            Inc(c);
          end;
        end;
        with dSatz do
        begin
          s:= IDNR+LfdNr+Zahl+Datum+Text+Betrag;  //String bilden
        end;
        memLog.Lines.Add(s);  //Soll so später in eine Textdatei geschrieben werden
        s:='';
     end;
    end
    else
    begin
      MessageDlg('Keine CSV Datei ausgewählt',mtError,[mbOK],0);
      FileDialog.SetFocus;
    end;
//  finally
//     document.Free;
//     memLog.Free;
//  end;
    btnClose.SetFocus;
end;



procedure TForm1.btnCloseClick(Sender: TObject);
begin
    document.Free;
    memLog.Free;
    Close;
end;


end.

